#include "gtkipcalc.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"

GtkWidget *net_entry = NULL;
GtkWidget *mask_button = NULL;
GtkWidget *bits_button = NULL;
GtkWidget *addrs_button = NULL;
GtkWidget *mask_entry = NULL;
GtkWidget *bits_entry = NULL;
GtkWidget *addrs_entry = NULL;
GtkWidget *broadcast_entry = NULL;
GtkWidget *gw_entry = NULL;
GtkWidget *range_start_entry = NULL;
GtkWidget *range_end_entry = NULL;

void show_main_window(void)
{
  GtkWidget *main_window;
  GtkWidget *main_layot;
  GtkWidget *input_frame;
  GtkWidget *input_layot;
  GtkWidget *net_layot;
  GtkWidget *net_title;
  GtkWidget *mask_layot;
  GtkWidget *type_box;
  GSList *type_box_group = NULL;
  GtkWidget *mask_entry_layot;
  GtkWidget *mask_combo;
  GList *mask_combo_items = NULL;
  GtkWidget *output_frame;
  GtkWidget *output_layot;
  GtkWidget *output_titles;
  GtkWidget *bc_title;
  GtkWidget *gw_title;
  GtkWidget *ar_title;
  GtkWidget *output_titles_layot;
  GtkWidget *bc_hbox;
  GtkWidget *gw_hbox;
  GtkWidget *ar_hbox;
  GtkWidget *ar_space;
  GtkWidget *button_area;
  GtkWidget *apply_button;
  GtkWidget *exit_button;

  main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width(GTK_CONTAINER(main_window), 5);
  gtk_window_set_title(GTK_WINDOW(main_window), _("GtkIPcalc"));
  gtk_window_set_policy(GTK_WINDOW(main_window), FALSE, FALSE, FALSE);

  main_layot = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(main_window), main_layot);

  input_frame = gtk_frame_new(_("Input"));
  gtk_box_pack_start(GTK_BOX(main_layot), input_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(input_frame), 5);

  input_layot = gtk_hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(input_frame), input_layot);
  gtk_container_set_border_width(GTK_CONTAINER(input_layot), 5);

  net_layot = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(input_layot), net_layot, TRUE, TRUE, 0);

  net_title = gtk_label_new(_("Network"));
  gtk_box_pack_start(GTK_BOX(net_layot), net_title, TRUE, TRUE, 0);
  gtk_misc_set_alignment(GTK_MISC(net_title), 0, 0.5);

  net_entry = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(net_layot), net_entry, FALSE, TRUE, 5);

  mask_layot = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(input_layot), mask_layot, TRUE, TRUE, 0);

  type_box = gtk_vbox_new(TRUE, 0);
  gtk_box_pack_start(GTK_BOX(mask_layot), type_box, TRUE, TRUE, 0);

  mask_button = gtk_radio_button_new_with_label(type_box_group, _("Mask"));
  type_box_group = gtk_radio_button_group(GTK_RADIO_BUTTON(mask_button));
  gtk_box_pack_start(GTK_BOX(type_box), mask_button, TRUE, TRUE, 0);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(mask_button), TRUE);

  bits_button = gtk_radio_button_new_with_label(type_box_group, _("Bits"));
  type_box_group = gtk_radio_button_group(GTK_RADIO_BUTTON(bits_button));
  gtk_box_pack_start(GTK_BOX(type_box), bits_button, TRUE, TRUE, 0);

  addrs_button = gtk_radio_button_new_with_label(type_box_group, _("Addresses"));
  type_box_group = gtk_radio_button_group(GTK_RADIO_BUTTON(addrs_button));
  gtk_box_pack_start(GTK_BOX(type_box), addrs_button, TRUE, TRUE, 0);

  mask_entry_layot = gtk_vbox_new(TRUE, 0);
  gtk_box_pack_start(GTK_BOX(mask_layot), mask_entry_layot, TRUE, TRUE, 0);

  mask_combo = gtk_combo_new();
  gtk_box_pack_start(GTK_BOX(mask_entry_layot), mask_combo, TRUE, TRUE, 0);
  mask_combo_items = g_list_append(mask_combo_items, (gpointer) "255.0.0.0");
  mask_combo_items = g_list_append(mask_combo_items, (gpointer) "255.255.0.0");
  mask_combo_items = g_list_append(mask_combo_items, (gpointer) "255.255.255.0");
  mask_combo_items = g_list_append(mask_combo_items, (gpointer) "255.255.255.192");
  mask_combo_items = g_list_append(mask_combo_items, (gpointer) "255.255.255.224");
  mask_combo_items = g_list_append(mask_combo_items, (gpointer) "255.255.255.240");
  mask_combo_items = g_list_append(mask_combo_items, (gpointer) "255.255.255.248");
  mask_combo_items = g_list_append(mask_combo_items, (gpointer) "255.255.255.252");
  gtk_combo_set_popdown_strings(GTK_COMBO(mask_combo), mask_combo_items);
  g_list_free(mask_combo_items);

  mask_entry = GTK_COMBO(mask_combo)->entry;
  gtk_entry_set_text(GTK_ENTRY(mask_entry), "");

  bits_entry = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(mask_entry_layot), bits_entry, TRUE, TRUE, 0);
  gtk_entry_set_editable(GTK_ENTRY(bits_entry), FALSE);

  addrs_entry = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(mask_entry_layot), addrs_entry, TRUE, TRUE, 0);
  gtk_entry_set_editable(GTK_ENTRY(addrs_entry), FALSE);

  output_frame = gtk_frame_new(_("Output"));
  gtk_box_pack_start(GTK_BOX(main_layot), output_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(output_frame), 5);

  output_layot = gtk_hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(output_frame), output_layot);
  gtk_container_set_border_width(GTK_CONTAINER(output_layot), 5);

  output_titles = gtk_vbox_new(TRUE, 0);
  gtk_box_pack_start(GTK_BOX(output_layot), output_titles, TRUE, TRUE, 0);

  bc_title = gtk_label_new(_("Broadcast"));
  gtk_box_pack_start(GTK_BOX(output_titles), bc_title, TRUE, TRUE, 0);
  gtk_misc_set_alignment(GTK_MISC(bc_title), 0, 0.5);

  gw_title = gtk_label_new(_("Default Gateway"));
  gtk_box_pack_start(GTK_BOX(output_titles), gw_title, TRUE, TRUE, 0);
  gtk_misc_set_alignment(GTK_MISC(gw_title), 0, 0.5);

  ar_title = gtk_label_new(_("Address range"));
  gtk_box_pack_start(GTK_BOX(output_titles), ar_title, TRUE, TRUE, 0);
  gtk_misc_set_alignment(GTK_MISC(ar_title), 0, 0.5);

  output_titles_layot = gtk_vbox_new(TRUE, 0);
  gtk_box_pack_start(GTK_BOX(output_layot), output_titles_layot, FALSE, TRUE, 0);

  bc_hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(output_titles_layot), bc_hbox, FALSE, TRUE, 0);

  broadcast_entry = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(bc_hbox), broadcast_entry, FALSE, TRUE, 5);
  gtk_entry_set_editable(GTK_ENTRY(broadcast_entry), FALSE);

  gw_hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(output_titles_layot), gw_hbox, FALSE, TRUE, 0);

  gw_entry = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(gw_hbox), gw_entry, FALSE, TRUE, 5);
  gtk_entry_set_editable(GTK_ENTRY(gw_entry), FALSE);

  ar_hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(output_titles_layot), ar_hbox, FALSE, TRUE, 0);

  range_start_entry = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(ar_hbox), range_start_entry, FALSE, TRUE, 5);
  gtk_entry_set_editable(GTK_ENTRY(range_start_entry), FALSE);

  ar_space = gtk_label_new("-");
  gtk_box_pack_start(GTK_BOX(ar_hbox), ar_space, FALSE, TRUE, 0);

  range_end_entry = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(ar_hbox), range_end_entry, FALSE, TRUE, 5);
  gtk_entry_set_editable(GTK_ENTRY(range_end_entry), FALSE);

  button_area = gtk_hbutton_box_new();
  gtk_box_pack_start(GTK_BOX(main_layot), button_area, TRUE, TRUE, 0);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(button_area), GTK_BUTTONBOX_SPREAD);

  apply_button = gtk_button_new_with_label(_("Apply"));
  gtk_container_add(GTK_CONTAINER(button_area), apply_button);

  exit_button = gtk_button_new_with_label(_("Exit"));
  gtk_container_add(GTK_CONTAINER(button_area), exit_button);

  gtk_signal_connect(GTK_OBJECT(main_window),  "delete_event", GTK_SIGNAL_FUNC(gtk_main_quit),           NULL);
  gtk_signal_connect(GTK_OBJECT(mask_button),  "toggled",      GTK_SIGNAL_FUNC(on_type_toggled),         "M");
  gtk_signal_connect(GTK_OBJECT(bits_button),  "toggled",      GTK_SIGNAL_FUNC(on_type_toggled),         "B");
  gtk_signal_connect(GTK_OBJECT(addrs_button), "toggled",      GTK_SIGNAL_FUNC(on_type_toggled),         "A");
  gtk_signal_connect(GTK_OBJECT(apply_button), "clicked",      GTK_SIGNAL_FUNC(on_apply_button_clicked), NULL);
  gtk_signal_connect(GTK_OBJECT(exit_button),  "clicked",      GTK_SIGNAL_FUNC(gtk_main_quit),           NULL);

  gtk_widget_show_all(main_window);
}

void show_error_window(gchar * text)
{
  GtkWidget *error_window;
  GtkWidget *layot;
  GtkWidget *error_label;
  GtkWidget *button_area;
  GtkWidget *error_ok_button;

  error_window = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_widget_set_usize(error_window, 200, 100);
  gtk_window_set_title(GTK_WINDOW(error_window), _("Error!"));
  gtk_window_set_modal(GTK_WINDOW(error_window), TRUE);
  gtk_window_set_policy(GTK_WINDOW(error_window), FALSE, FALSE, FALSE);

  layot = gtk_vbox_new(TRUE, 0);
  gtk_container_add(GTK_CONTAINER(error_window), layot);
  gtk_widget_set_usize(layot, 64, 40);

  error_label = gtk_label_new(text);
  gtk_box_pack_start(GTK_BOX(layot), error_label, FALSE, TRUE, 0);

  button_area = gtk_hbutton_box_new();
  gtk_box_pack_start(GTK_BOX(layot), button_area, TRUE, TRUE, 0);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(button_area), GTK_BUTTONBOX_SPREAD);

  error_ok_button = gtk_button_new_with_label(_("OK"));
  gtk_container_add(GTK_CONTAINER(button_area), error_ok_button);

  gtk_signal_connect_object(GTK_OBJECT(error_ok_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));

  gtk_widget_show_all(error_window);
}
